"use strict";
this.name 			= "spawnPolicePatrol"; // in-system, milkrun and interstellar patrols
this.author 		= "rustem";
this.copyright 		= "2018 Creative Commons: attribution, non-commercial, sharealike."; // CC BY-NC-SA 4.0
this.description	= "Conditional spawning of interceptors with sniper guns(interceptor-sg) from Rich(Corp & Democracy) systems";
this.version 		= "0.3";

// This is modification of spara's rh-boss-spawn-shipset script

// this._shipSpawnOverride = false;

this.logging = false; // false/true

this.allowSpawnShip = function(shipKey)
{
	// Sanity check
	if (!system.sun || system.sun.isGoingNova || system.sun.hasGoneNova) {
		if (!system.isInterstellarSpace)
			return false;
	}

	var adjacent, homeSystem; // var shipKey = dataKey;

	// An corp system (G1..8), that's where the interceptor-sg get support. // Total systems : 32 (Corporate State - 0, Democracy - 64 in Galaxy 4, )
	// economy: 0 (Rich Industrial) ... 7 (Poor Agricultural)
	//
		// stats:
		// Rich Ind in the Charts(sectors): Totals(Corporate State + Democracy): [30(7),  26(10), 30(10), 24(8),  25(8),  25(8),  38(22), 20(8)]
		// Technology Level( > 9):          Totals(Corporate State + Democracy): [81(31), 73(35), 65(29), 63(29), 84(38), 83(27), 81(43), 73(31)]
		//
		// replaced police to interceptor: if (9+Math.random()*6 < system.info.techlevel). / may be recalc the stats data for TL > 8 above?

	//if (system.government === 0)
	if (system.economy === 0 && system.government > 5) { // Rich Industrial //system.economy === 0 && system.government === 7
		if (this.logging) {
			homeSystem = system;
			player.consoleMessage("Spawning in Rich system: " + shipKey, 8);
			log("sniperguns_shipset_pack", "Spawning in Rich system: " + shipKey + " from this system");
		}
		return true;
	}
	// Ok, not an corp system, but maybe there is such a system close by.
	var adjacentSystems = system.info.systemsInRange(7);
	var safeHood = false;
	for (var i = 0; i < adjacentSystems.length; i++) {
		adjacent = System.infoForSystem(adjacentSystems[i].galaxyID, adjacentSystems[i].systemID);
		if (adjacent.economy === 0 && adjacent.government > 5) { // Rich Industrial(safeHood) = Rich Corporate + Democracy //adjacent.economy === 0 && adjacent.government === 7
			safeHood = true;
			homeSystem = adjacent; //log("sniperguns_shipset_pack", "Found nearby Rich homeSystem");
			break;
		}
	}

	// This is safe hood, there is an corp system next door.
	if (safeHood) {
		// 1 rule: addition in the interstellar space ~ (interstellar patrol)		
		if (system.isInterstellarSpace) {
			if (this.logging) {
				player.consoleMessage("Spawning in the interstellar space: " + shipKey, 8);
				log("sniperguns_shipset_pack", "Spawning in the interstellar space.");
			}
			return true;
		// 2 rule: addition in the milkrun ~ (milkrun patrol)			
		} else if (5+Math.random()*2 < system.economy) { // system.economy > 5 // stats: [100,75]
			if (this.logging) {
				player.consoleMessage("Spawning in the milkrun: " + shipKey, 8);
				log("sniperguns_shipset_pack", "Spawning in the milkrun.");
			}
			return true; 
		// 3 rule: Sometimes interceptor-sg visit nearby systems. Lower the government, rarer the incident (Rich zone).
		// v1 - test string:
		//} else if (Math.random()*system.government/3 > 1) {                       // Corporate - Feudal     ~ [85,85,78,45,,,,]
		//} else if (Math.random()*(system.government - 3)/4 > Math.random()) {     // Corporate - Communist  ~ [75,,44,25] // 64
		} else if (3+Math.random()*4 < system.government) {                       // Corporate - Communist  ~ [100,95,90,45]
		//} else if (3+Math.random()*5 < system.government) {                       // Corporate - Communist  ~ [95,,,35]
		//} else if (3+Math.random()*3 < system.government) {                       // Corporate - Communist  ~ [100,100,90,50]
		// v2 - added a high tech zone:
		//} else if (3 + Math.random() * 3 < system.government || 9 + Math.random() * 6 < system.info.techlevel) { // Corporate - Communist    ~ TL(15)[100,100,100?,100?,,,],TL(14)[100,100,99?,50?,,,,],TL(13)[100,100,98,50?,,,],TL(12)[100,100,90,50,,,,],TL(11)[100,100,,,50,,,],TL(10)[100,100,,,,28,,] + TL(9)[100,100,90,50,0,0,0,0] + ... + TL(x)[...] + ... + TL(0)[100,100,90,50,0,0,0,0].
																						// Rich Corporate & (Democracy || Corporate) = 100% prob-ty (link, avail-le).
																						// Rich Democracy & (Corporate || Democracy) = 100% prob-ty.
																						// Rich safeHood  & (Confederacy || Communist) = var prob-ty from TL
			if (this.logging) {
				player.consoleMessage("Spawning in Rich zone: " + shipKey, 8);
				log("sniperguns_shipset_pack", "Spawning in Rich zone: " + shipKey + " from " + homeSystem.systemID); // and high tech
			}
			return true;
		}		
	}
	return false;
}
